【Leetcode 2273 】 移除字母异位词后的结果数组 —— 三种版本,时间击败100%,空间击败100%

本文主要是介绍【Leetcode 2273 】 移除字母异位词后的结果数组 —— 三种版本,时间击败100%,空间击败100%,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

给你一个下标从 0 开始的字符串 words ,其中 words[i] 由小写英文字符组成。

在一步操作中,需要选出任一下标 i ,从 words 中 删除 words[i] 。其中下标 i 需要同时满足下述两个条件:

  1. 0 < i < words.length
  2. words[i - 1] 和 words[i] 是 字母异位词 。

只要可以选出满足条件的下标,就一直执行这个操作。

在执行所有操作后,返回 words 。可以证明,按任意顺序为每步操作选择下标都会得到相同的结果。

字母异位词 是由重新排列源单词的字母得到的一个新单词,所有源单词中的字母通常恰好只用一次。例如,"dacb" 是 "abdc" 的一个字母异位词。

示例 1:

输入:words = ["abba","baba","bbaa","cd","cd"]
输出:["abba","cd"]
解释:
获取结果数组的方法之一是执行下述步骤:
- 由于 words[2] = "bbaa" 和 words[1] = "baba" 是字母异位词,选择下标 2 并删除 words[2] 。现在 words = ["abba","baba","cd","cd"] 。
- 由于 words[1] = "baba" 和 words[0] = "abba" 是字母异位词,选择下标 1 并删除 words[1] 。现在 words = ["abba","cd","cd"] 。
- 由于 words[2] = "cd" 和 words[1] = "cd" 是字母异位词,选择下标 2 并删除 words[2] 。现在 words = ["abba","cd"] 。
无法再执行任何操作,所以 ["abba","cd"] 是最终答案。

示例 2:

输入:words = ["a","b","c","d","e"]
输出:["a","b","c","d","e"]
解释:
words 中不存在互为字母异位词的两个相邻字符串,所以无需执行任何操作。

提示:

  • 1 <= words.length <= 100
  • 1 <= words[i].length <= 10
  • words[i] 由小写英文字母组成

第一版本 

执行用时:97 ms, 在所有 Typescript 提交中击败了 - %的用户
内存消耗:59.62 MB, 在所有 Typescript 提交中击败了 - %的用户

/*
第一版本
https://leetcode.cn/u/cshappyeveryday/
执行用时:97 ms, 在所有 Typescript 提交中击败了 - %的用户
内存消耗:59.62 MB, 在所有 Typescript 提交中击败了 - %的用户
时间复杂度:O(n*m)
2024年8月30日 
*/
function removeAnagrams(words: string[]): string[] {const OFFSET = "a".charCodeAt(0);let sucP = 1;//二维数组存储每个字符的charCodeconst twoDimension = new Array(words.length).fill([]).map(() => new Array(26).fill(0));for (let i = 0; i < words.length; i++) {for (const char of words[i]) {twoDimension[i][char.charCodeAt(0) - OFFSET]++;}}for (let i = 1; i < words.length; i++) {//判断两个内容是否完全相等const diff = twoDimension[i].filter((n, j) => n === twoDimension[i - 1][j]);if (diff.length === twoDimension[i].length) continue;//在原数组上保存结果数据words[sucP++] = words[i];}return words.slice(0, sucP);
}

第二版本


执行用时:75 ms, 在所有 Typescript 提交中击败了 60.00 %的用户
内存消耗:55.16 MB, 在所有 Typescript 提交中击败了 100.00 %的用户 

/*
第二版本
https://leetcode.cn/u/cshappyeveryday/
执行用时:75 ms, 在所有 Typescript 提交中击败了 60.00 %的用户
内存消耗:55.16 MB, 在所有 Typescript 提交中击败了 100.00 %的用户
时间复杂度:O(n*m)
2024年8月30日 
*/
function removeAnagrams2(words: string[]): string[] {const OFFSET = "a".charCodeAt(0);let sucP = 1;for (let i = 1; i < words.length; i++) {let curWordCode = new Array(26).fill(0);let preWordCode = new Array(26).fill(0);//每一次都计算当前与上一次的charCodefor (const word of words[i]) {curWordCode[word.charCodeAt(0) - OFFSET]++;}for (const word of words[i - 1]) {preWordCode[word.charCodeAt(0) - OFFSET]++;}const isSame = curWordCode.every((n, j) => n === preWordCode[j]);if (isSame) continue;words[sucP++] = words[i];}return words.slice(0, sucP);
}

最终版本

执行用时:67 ms, 在所有 Typescript 提交中击败了 100.00 %的用户

内存消耗:54.29 MB, 在所有 Typescript 提交中击败了 100.00 %的用户

/*
最终版本
https://leetcode.cn/u/cshappyeveryday/
执行用时:67 ms, 在所有 Typescript 提交中击败了 100.00 %的用户
内存消耗:54.29 MB, 在所有 Typescript 提交中击败了 100.00 %的用户
时间复杂度:O(n * m)
2024年8月30日 
*/
function removeAnagrams3(words: string[]): string[] {const OFFSET = "a".charCodeAt(0);let sucP = 1; //成功指针,指向words,该指针前面的元素都是结果let curWordCode = new Array<number>(26).fill(0); //当前 wordCodelet preWordCode = new Array<number>(26).fill(0); //上一个wordCode// 初始化 preWordCodefor (const word of words[0]) {preWordCode[word.charCodeAt(0) - OFFSET]++;}for (let i = 1; i < words.length; i++) {//去除和上一个相同的,注意:这里的去重与 Set() 去重不同。Set会将所有相同的去除,这里只针对相邻的两个if (words[i] === words[i - 1]) continue;curWordCode = new Array<number>(26).fill(0);for (const word of words[i]) {curWordCode[word.charCodeAt(0) - OFFSET]++;}//判断上一次成功的值与本次是否为 字母内容相同的const isSame =curWordCode.length === preWordCode.length &&curWordCode.every((n, j) => n === preWordCode[j]);//   是则证明不是 字母异位词,跳过if (isSame) continue;// 不是,则证明是 字母异位词,则 preWordCode 变成本次wordpreWordCode = [...curWordCode];//修改 结果,将成功指针后移words[sucP++] = words[i];}//依据 sucP 的位置返回结果return words.slice(0, sucP);
}

这篇关于【Leetcode 2273 】 移除字母异位词后的结果数组 —— 三种版本,时间击败100%,空间击败100%的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1121907

相关文章

哈希leetcode-1

目录 1前言 2.例题  2.1两数之和 2.2判断是否互为字符重排 2.3存在重复元素1 2.4存在重复元素2 2.5字母异位词分组 1前言 哈希表主要是适合于快速查找某个元素(O(1)) 当我们要频繁的查找某个元素,第一哈希表O(1),第二,二分O(log n) 一般可以分为语言自带的容器哈希和用数组模拟的简易哈希。 最简单的比如数组模拟字符存储,只要开26个c

服务器集群同步时间手记

1.时间服务器配置(必须root用户) (1)检查ntp是否安装 [root@node1 桌面]# rpm -qa|grep ntpntp-4.2.6p5-10.el6.centos.x86_64fontpackages-filesystem-1.41-1.1.el6.noarchntpdate-4.2.6p5-10.el6.centos.x86_64 (2)修改ntp配置文件 [r

hdu2241(二分+合并数组)

题意:判断是否存在a+b+c = x,a,b,c分别属于集合A,B,C 如果用暴力会超时,所以这里用到了数组合并,将b,c数组合并成d,d数组存的是b,c数组元素的和,然后对d数组进行二分就可以了 代码如下(附注释): #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<que

Android实现任意版本设置默认的锁屏壁纸和桌面壁纸(两张壁纸可不一致)

客户有些需求需要设置默认壁纸和锁屏壁纸  在默认情况下 这两个壁纸是相同的  如果需要默认的锁屏壁纸和桌面壁纸不一样 需要额外修改 Android13实现 替换默认桌面壁纸: 将图片文件替换frameworks/base/core/res/res/drawable-nodpi/default_wallpaper.*  (注意不能是bmp格式) 替换默认锁屏壁纸: 将图片资源放入vendo

usaco 1.2 Name That Number(数字字母转化)

巧妙的利用code[b[0]-'A'] 将字符ABC...Z转换为数字 需要注意的是重新开一个数组 c [ ] 存储字符串 应人为的在末尾附上 ‘ \ 0 ’ 详见代码: /*ID: who jayLANG: C++TASK: namenum*/#include<stdio.h>#include<string.h>int main(){FILE *fin = fopen (

hdu 1166 敌兵布阵(树状数组 or 线段树)

题意是求一个线段的和,在线段上可以进行加减的修改。 树状数组的模板题。 代码: #include <stdio.h>#include <string.h>const int maxn = 50000 + 1;int c[maxn];int n;int lowbit(int x){return x & -x;}void add(int x, int num){while

leetcode-24Swap Nodes in Pairs

带头结点。 /*** Definition for singly-linked list.* public class ListNode {* int val;* ListNode next;* ListNode(int x) { val = x; }* }*/public class Solution {public ListNode swapPairs(L

leetcode-23Merge k Sorted Lists

带头结点。 /*** Definition for singly-linked list.* public class ListNode {* int val;* ListNode next;* ListNode(int x) { val = x; }* }*/public class Solution {public ListNode mergeKLists

C++ | Leetcode C++题解之第393题UTF-8编码验证

题目: 题解: class Solution {public:static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num &

【每日一题】LeetCode 2181.合并零之间的节点(链表、模拟)

【每日一题】LeetCode 2181.合并零之间的节点(链表、模拟) 题目描述 给定一个链表,链表中的每个节点代表一个整数。链表中的整数由 0 分隔开,表示不同的区间。链表的开始和结束节点的值都为 0。任务是将每两个相邻的 0 之间的所有节点合并成一个节点,新节点的值为原区间内所有节点值的和。合并后,需要移除所有的 0,并返回修改后的链表头节点。 思路分析 初始化:创建一个虚拟头节点